#!/usr/bin/python

# Temp controller script by Mattias Sjogren
# Free to copy
# 2013-01-22

import requests, time

allOk = 1

try:
    # Get all devices
    url = 'http://192.168.0.50:8080/json.htm?type=devices&used=true'
    resp = requests.get(url)
except:
    print ("Error, no server")    
    allOk = 0;
    
if allOk == 1:
    if resp.status_code == requests.codes.ok:
        devices = resp.json()
    else:
        allOk = 0

# Get all temperatures
url = 'http://192.168.0.50:8080/json.htm?type=status-temp'

if allOk == 1:
    resp = requests.get(url)
    if resp.status_code == requests.codes.ok:
        temperatures = resp.json()
    else:
        allOk = 0


if allOk == 1:
    # Extract the required data
    data = [
        { 'temp_name' : 'Garaget',
          'switch_name' : 'Heater garage',
          'temp':-999.0,
          'temp_time': 0,
          'switch_time': 0,
          'switch_idx': 0,
          'curr_switch_status': 'Off',
          'new_switch_status': 'Off',
          'on_temp' : 4.0,
          'off_temp' : 4.5},
        { 'temp_name' : 'Kaminen',
          'switch_name' : 'Fan kaminen',
          'temp':-999.0,
          'temp_time': 0,
          'switch_time': 0,
          'switch_idx': 0,
          'curr_switch_status': 'Off',
          'new_switch_status': 'Off',
          'on_temp' : 35.0,
          'off_temp' : 25.0}
        ]

    # Go through all the data
    for d in data:
        # Get current temperature
        for x in temperatures['result']:
            if x['Name'] == d['temp_name']:
                d['temp'] = x['Temp']
                d['temp_time'] = time.strptime(x['LastUpdate'], "%Y-%m-%d %H:%M:%S")
                
        # Get switch status
        for x in devices['result']:
            if x['Name'] == d['switch_name']:
                d['switch_time'] = time.strptime(x['LastUpdate'], "%Y-%m-%d %H:%M:%S")
                d['switch_idx'] = x['idx']
                d['curr_switch_status'] = x['Status']
                
        # Check if the switch should be changed
        if d['on_temp'] < d['off_temp']:
            # This is a heater
            if d['temp'] < d['on_temp']:
                d['new_switch_status'] = 'On'
                d['curr_switch_status'] = 'Off' # Keep sending this if below On temp
            elif d['temp'] > d['off_temp']:
                d['new_switch_status'] = 'Off'
            # else, do nothing
            else: d['new_switch_status'] = d['curr_switch_status']
        else:
            # This is a cooling fan
            if d['temp'] > d['on_temp']:
                d['new_switch_status'] = 'On'
            elif d['temp'] < d['off_temp']:
                d['new_switch_status'] = 'Off'
            # else, do nothing
            else: d['new_switch_status'] = d['curr_switch_status']

        if d['new_switch_status'] != d['curr_switch_status']:
            url = 'http://192.168.0.50:8080/json.htm?type=command&param=switchlight&idx=' + d['switch_idx'] + '&switchcmd=' + d['new_switch_status']
            resp = requests.get(url)
        else:
            # Redo the last command every 30 minutes, just to be sure...
            if (time.time() - time.mktime(d['switch_time'])) > (30 * 60):
                url = 'http://192.168.0.50:8080/json.htm?type=command&param=switchlight&idx=' + d['switch_idx'] + '&switchcmd=' + d['new_switch_status']
                resp = requests.get(url)

        #print (d['temp_name'], "@", d['curr_switch_status'], ",", d['new_switch_status'], "\n") 

